#include "Vector.h"

#include "TestFramework.h"

#include <stdio.h>

TEST_CASE(TestVectorExtend, "core")
{
    Vector<size_t> vec;
    for(size_t idx=0; idx<16; idx++)
    {
        vec.push_back(idx);
    }
    REQUIRE(vec.size() == 16);

    Vector<size_t> vec0;
    for(size_t idx=16; idx<19; idx++)
    {
        vec0.push_back(idx);
    }
    vec.extend(vec0);
    REQUIRE(vec.size() == 19);
}

TEST_CASE(TestVectorSlize, "core")
{
    Vector<size_t> vec;
    for(size_t idx=0; idx<8; idx++)
    {
        vec.push_back(idx);
    }

    Vector<size_t> bottom_half;
    vec.slice(4, bottom_half);
    REQUIRE(bottom_half.size() == 4);

    Vector<size_t> top_half;
    vec.slice(4, 8, top_half);
    REQUIRE(top_half.size() == 4);

}
